#include	<corlib.h>
#include	<winop.h>
#include	<parts.h>
#include	<string.h>
#include	<HS_wlib.h>

#define WAIT	4

#define	INTATR	EventAttrDefault|EventMoveON|EventGraphicON|EventIntervalON
#define	NOINTATR	EventAttrDefault|EventMoveON|EventGraphicON


int WindowHeapSize= 0;
unsigned int	Time, ct;
unsigned short	*gadr;
unsigned short	palette[16];
unsigned char	pat[32 * 256],
				map[32 * 1024];

extern void	init();
extern void	move( WindowID );
extern void	SetPalet();
extern void	putbg( int, unsigned short* );
static int	loadmap( char* );
static int	MainExec( WindowID, EventInfo* );
void	WindowMain( int, char** );

static int
loadmap( fname )
char	*fname;
{
	FILE	*fp;

	fp= fopen( fname, "rb" );
	if( !fp ){
		ConsoleOpen();
		ConsolePrint( "file cannot open\n" );
		return FALSE;
	}

	fread( palette, sizeof( unsigned short ), 16, fp );
	SetPalet();
	fread( pat, sizeof( unsigned short ), 32 * 256, fp );
	fread( map, sizeof( unsigned char ), 32 * 1024, fp );

	fclose( fp );
	return TRUE;
}

static void
calcadr( wp )
WindowID	wp;
{
	int	x, y;

	WindowGetScreenPosition( wp, &x, &y );
	if( x < 0 || x > 832 || y < 0 || y > 768 ){
		WindowSetEventAttr( wp, NOINTATR );
		return;
	}
	y+= 252;
	gadr= (unsigned short*)0xc00000 + ( y * 1024 ) + x;
	WindowSetEventAttr( wp, INTATR );
}

static int
MainExec( wp, info )
WindowID wp;
EventInfo *info;
{
	DrawBuf dbuf[2], *dp= dbuf;

	switch(info->option){
		case EventInterval:
			if( IntervalWait( WAIT, &Time ) ){
				move( wp );
				putbg( ct, gadr );
				if( ++ct > 960 )	ct= 0;
				return TRUE;
			}
			return FALSE;

		case EventOpen:
			ct= 0;
			init();
			WindowSetAttr( wp, WindowAttrGraphic16 );
			calcadr( wp );
			WindowRedraw( wp );
			return TRUE;

		case EventMove:
			WindowMove( wp, info->x, info->y );
			calcadr( wp );
			WindowRedraw( wp );
			return TRUE;

		case EventClose:
			WindowClose( wp );
			WindowConnectionClose();
			return TRUE;

		case EventGraphic:
			if( info->x == WindowAttrGraphic16 ){
				calcadr( wp );
			}
			return TRUE;

		case EventRedraw:
			SetPalet();
			DrawSetClear( dp++, 2 );
			WindowDraw( wp, dbuf, dp - dbuf );
			return TRUE;

		default:
			return FALSE;
	}
}

void
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int x= 127, y= 128;

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	if( argc && loadmap( *++argv ) ){
		WindowTitleOpen( x, y, 192, 256, NULL, "EZO2", Push|Close, MainExec );
	}else {
		ConsoleOpen();
		ConsolePrint( "ezo2 : map file is needed\n" );
		WindowConnectionClose();
	}
}
