#include	<corlib.h>
#include	<winop.h>
#include	<mm_alloc.h>
#include	<HS_wlib.h>
#include	<string.h>

int	WindowHeapSize= 16 * 1024;


WindowID	swp;

int	ox, oy,
	lx1, ly1, lx2, ly2,
	cw, ch,
	mode, second,
	cpat;

unsigned char	*cpbuf;
char	filename[92];
unsigned char	pat[128 * 64];
unsigned char	vpat[128 * 64];
unsigned char	vgram[192 * 264];
unsigned char	map[24 * 1024];
unsigned char	vpal[128 * 8];
unsigned short	palette[16];

#include	"MapBut.C"

extern void	putbg( int, unsigned char*, unsigned char* );
extern void SetPalet();
extern void	loadfile( unsigned char* );
extern int	inpwin( WindowID, EventInfo* );
extern void	savemap( unsigned char* );


static void
init()
{
	int	i, j;

	for( i= 0; i < 128 * 64; i++ ){
		pat[i]= 0;
		vpat[i]= 0;
	}
	for( i= 0; i < 192 * 264; i++ ){
		vgram[i]= 0;
	}
	for( i= 0; i < 24 * 1024; i++ ){
		map[i]= 0;
	}
	for( i= 0; i < 16; i++ ){
		palette[i]= i;
	}
	for( i= 0; i < 8; i++ ){
		for( j= 0; j < 128; j++ ){
			vpal[i * 128 + j]= j / 8;
		}
	}

	ox= 0;
	oy= 0;
	lx1= -1;
	ly1= -1;
	lx2= -1;
	ly2= -1;
	mode= 0;
	cpat= 0;
	swp= NULL;
	cpbuf= NULL;
	*filename= NULL;
}

static void
setpat( wp, x, y )
WindowID	wp;
int	x;
int	y;
{
	DrawBuf	dbuf[2], *dp= dbuf;

	if( x != ox || y != oy ){
		DrawSetLine( dp++, ( ox << 3 ) + 216, ( oy << 2 ) + 16,
					( ox << 3 ) + 216 + 7, ( oy << 2 ) + 16 + 3,
					2, OptionBox );
		DrawSetLine( dp++, ( x << 3 ) + 216, ( y << 2 ) + 16,
					( x << 3 ) + 216 + 7, ( y << 2 ) + 16 + 3,
					3, OptionBox );
		WindowDraw( wp, dbuf, dp - dbuf );
		ox= x;
		oy= y;
	}
}

static void
setclip( c )
ClipClass *c;
{
	int	tmp;

	c->x1= lx1;
	if( c->x1 < 0 )	c->x1= 0;
	if( c->x1 >= 24 )	c->x1= 23;
	c->x2= lx2;
	if( c->x2 < 0 )	c->x2= 0;
	if( c->x2 >= 24 )	c->x2= 23;
	if( c->x1 > c->x2 ){
		tmp= c->x1;
		c->x1= c->x2;
		c->x2= tmp;
	}

	c->y1= ly1;
	if( c->y1 < 0 )	c->y1= 0;
	if( c->y1 >= 1024 )	c->y1= 1023;
	c->y2= ly2;
	if( c->y2 < 0 )	c->y2= 0;
	if( c->y2 >= 1024 )	c->y2= 1023;
	if( c->y1 > c->y2 ){
		tmp= c->y1;
		c->y1= c->y2;
		c->y2= tmp;
	}
}

static void
getbuf()
{
	int	i, j;
	unsigned char	*ptr;
	ClipClass	c;

	setclip( &c );

	if( cpbuf ){
		free( cpbuf );
		cpbuf= NULL;
	}
	cw= c.x2 - c.x1 + 1;
	ch= c.y2 - c.y1 + 1;
	cpbuf= malloc( cw * ch );
	if( !cpbuf ){
		ConsoleOpen();
		ConsolePrint( "memory exhausted\n" );
		return;
	}
	ptr= cpbuf;
	for( j= c.y1; j <= c.y2; j++ ){
		for( i= c.x1; i <= c.x2; i++ ){
			*ptr++= map[j * 24 + i];
		}
	}
}

static void
putbuf( x, y )
int	x, y;
{
	int	i, j, k, l;

	if( !cpbuf )	return;

	if( x + cw > 24 ){
		i= 24 - x;
	}else {
		i= cw;
	}
	if( y + ch > 1024 ){
		j= 1024 - y;
	}else {
		j= ch;
	}

	for( l= 0; l < j; l++ ){
		for( k= 0; k < i; k++ ){
			map[( y + l ) * 24 + ( x + k )]= cpbuf[l * cw + k];
		}
	}
}

static void
nbox( wp, c )
WindowID	wp;
int	c;
{
	int	x1, y1, x2, y2;
	DrawBuf	dbuf[1], *dp= dbuf;

	if( lx1 > lx2 ){
		x1= lx2;
		x2= lx1;
	}else {
		x1= lx1;
		x2= lx2;
	}
	if( ly1 > ly2 ){
		y1= ly2;
		y2= ly1;
	}else {
		y1= ly1;
		y2= ly2;
	}
	DrawSetLine( dp, x1 << 3, y1 << 2, ( x2 << 3 ) + 7,
				( y2 << 2 ) + 3, c, OptionBox );
	WindowDraw( wp, dbuf, 1 );
}

static void
buttonope( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[2], *dp= dbuf;
	int	oldmode, x= ( info->x - 216 ) >> 4;

	if( x == mode || x >= 4 )	return;
	DrawSetLine( dp++, mode * 16 + 216, 90,
					mode * 16 + 216 + 15, 90 + 15,
					1|OptionXor, OptionFill );
	DrawSetLine( dp++, x * 16 + 216, 90,
					x * 16 + 216 + 15, 90 + 15,
					1|OptionXor, OptionFill );
	WindowDraw( wp, dbuf, dp - dbuf );
	switch( x ){
	case 0:
	case 1:
	case 2:
		mode= x;
		second= FALSE;
		nbox( swp, 2 );
		break;
	case 3:
		oldmode= mode;
		mode= 3;
		if( inpwin( wp, info ) ){
			if( !strchr( filename, '.' ) ){
				strcat( filename, ".map" );
			}
			savemap( filename );
		}
		mode= oldmode;
		WindowRedraw( wp );
		break;
	}
}

static int
userop( wp, info )
WindowID	wp;
EventInfo	*info;
{
	switch( info->ComData ){
	case UserString:
	case UserPaste:
		loadfile( (unsigned char*)info->ComBuffer );
		WindowRedraw( wp );
		return TRUE;
	case UserStrings:
	{
		unsigned char	**ptr= (unsigned char**)info->ComBuffer;
		while( *ptr ){
			loadfile( *ptr );
			ptr++;
		}
		WindowRedraw( wp );
		return TRUE;
	}
	default:
		return FALSE;
	}
}

static void
gfill()
{
	int	i, j;
	ClipClass	c;

	setclip( &c );

	for( j= c.y1; j <= c.y2; j++ ){
		for( i= c.x1; i <= c.x2; i++ ){
			map[j * 24 + i]= cpat;
		}
	}
}

static int
ScrollExec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf dbuf[2], *dp= dbuf;

	switch(info->option){
	case EventOpen:
		WindowSetAttr( wp, WindowAttrGraphic16 );
		WindowSetEventAttr( wp, EventAttrDefault|EventGraphicON|EventUserON|EventMouseMoveON );
		WindowRedraw( wp );
		WindowScroll( wp, 0, 4096 );
		return TRUE;

	case EventClose:
		WindowClose( wp );
		swp= NULL;
		WindowSendSignal( WindowProcessID, SignalKill, 0 );
		return TRUE;

	case EventRedraw:
	{
		int	x, y, h;
		HS_WindowGetHome( wp, &x, &y );
		h= 63;
		if( x= y & 3 ){
			h++;
		}else {
			x= 4;
		}
		y = y >> 2;

		putbg( h, vgram + x * 192, map + y * 24 );
		DrawSetClear( dp++, 2 );
		DrawSetGraphicPut( dp++, 0, info->y - 4, 191,
							info->y + 263 - 4, vgram );
		WindowDraw( wp, dbuf, dp - dbuf );
		return TRUE;
	}

	case EventUser:
		return userop( HS_WindowGetParent( wp ), info );

	case EventMouseMove:
		if( second ){
			nbox( wp, 2 );
			lx2= info->x >> 3;
			ly2= info->y >> 2;
			nbox( wp, 3 );
			return TRUE;
		}else if( mode == 2 && cpbuf ){
			nbox( wp, 2 );
			lx1= info->x >> 3;
			ly1= info->y >> 2;
			lx2= lx1 + cw - 1;
			ly2= ly1 + ch - 1;
			nbox( wp, 3 );
			return TRUE;
		}
		return FALSE;

	case EventMouseSwitch:
	{
		int	x= info->x >> 3,
			y= info->y >> 2;

		switch( mode ){
		case 0:
			if( info->LeftON || info->LeftStat ){
				map[y * 24 + x]= cpat;
				DrawSetGraphicPut( dp++, x << 3, y << 2,
								( x << 3 ) + 7, ( y << 2 ) + 3,
								&(pat[cpat * 32]) );
				WindowDraw( wp, dbuf, 1 );
				return TRUE;
			}else if( info->RightON || info->RightStat ){
				cpat= map[y * 24 + x];
				y= cpat >> 4;
				x= cpat & 15;
				setpat( HS_WindowGetParent( wp ), x, y );
				return TRUE;
			}
			break;
		case 1:
			if( info->LeftON ){
				if( second ){
					gfill();
					second= FALSE;
					WindowRedraw( wp );
				}else {
					lx1= lx2= x;
					ly1= ly2= y;
					second= TRUE;
					nbox( wp, 3 );
				}
				return TRUE;
			}else if( info->RightON ){
				if( second ){
					nbox( wp, 2 );
					second= FALSE;
				}else {
					cpat= map[y * 24 + x];
					y= cpat >> 4;
					x= cpat & 15;
					setpat( HS_WindowGetParent( wp ), x, y );
				}
				return TRUE;
			}
			break;
		case 2:
			if( info->LeftON ){
				if( second ){
					getbuf();
					second= FALSE;
					WindowRedraw( wp );
				}else if( cpbuf ){
					putbuf( x, y );
					WindowRedraw( wp );
				}else {
					lx1= lx2= x;
					ly1= ly2= y;
					second= TRUE;
					nbox( wp, 3 );
				}
				return TRUE;
			}else if( info->RightON ){
				nbox( wp, 2 );
				if( second ){
					second= FALSE;
				}else if( cpbuf ){
					free( cpbuf );
					cpbuf= NULL;
				}
				return TRUE;
			}
			break;
		}
	}
	}
	return FALSE;
}

static int
Exec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf dbuf[8], *dp= dbuf;

	if( WindowGetChild( wp, info ) ){
		return WindowSendEvent( swp, info );
	}

	switch(info->option){
	case EventOpen:
		WindowSetAttr( wp, WindowAttrGraphic16 );
		WindowSetEventAttr( wp, EventAttrDefault|EventGraphicON|EventUserON|EventMouseMoveON );
		swp= WindowScrollOpen( 4, 4, 195 + 10, 259, wp, 192, 4095,
								DirectionY, 0, 4, ScrollExec );
		WindowRedraw( wp );
		return TRUE;

	case EventClose:
		if( swp )	WindowClose( swp );
		WindowClose( wp );
		if( cpbuf ){
			free( cpbuf );
			cpbuf= NULL;
		}
		WindowConnectionClose();
		return TRUE;

	case EventRedraw:
		DrawSetClear( dp++, 1 );
		DrawSetLine( dp++, 216, 2, 343, 9, 2, OptionFill );
		DrawSetGraphicPut( dp++, 216, 2, 343, 9, vpal );
		DrawSetLine( dp++, 216, 16, 343, 79, 2, OptionFill );
		DrawSetGraphicPut( dp++, 216, 16, 343, 79, vpat );
		DrawSetLine( dp++, ( ox << 3 ) + 216, ( oy << 2 ) + 16,
					( ox << 3 ) + 216 + 7, ( oy << 2 ) + 16 + 3,
					3, OptionBox );
		DrawSetPut( dp++, 216, 90, &MapButPattern );
		DrawSetLine( dp++, mode * 16 + 216, 90,
						mode * 16 + 216 + 15, 90 + 15,
						1|OptionXor, OptionFill );
		WindowDraw( wp, dbuf, dp - dbuf );
		if( swp )	WindowRedraw( swp );
		SetPalet();
		return TRUE;

	case EventMouseSwitch:
		if( info->LeftON ){
			if( 216 <= info->x && info->x <= 343 ){
				if( 16 <= info->y && info->y <= 79 ){
					int	x, y;
					x= ( info->x - 216 ) >> 3;
					y= ( info->y - 16 ) >> 2;
					setpat( wp, x, y );
					cpat= y * 16 + x;
					return TRUE;
				}else if( 90 <= info->y && info->y <= 90 + 15 ){
					buttonope( wp, info );
					return TRUE;
				}
			}
		}
		return FALSE;

	case EventUser:
		return userop( wp, info );
	}
	return FALSE;
}

void
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int	x= 0, y= 256;

	init();

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	WindowTitleOpen( x, y, 350, 264, NULL, "EZOGIKU MAP", Close|Push, Exec );
}
